#!/bin/bash

# Copyright (C) 2020  Tetras Libre <Contact@Tetras-Libre.fr>
# Author: Beniamine, David <David.Beniamine@Tetras-Libre.fr>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

if [ -z "$2" ] || [ "$1" != 'Name' ] && [ "$1" != 'MAC' ]
then
    echo "Usage:"
    echo "\t $0 MAC aa:bb:cc:dd:ee:ff"
    echo "Or"
    echo "\t $0 Name hostname"
    exit 1
fi

lease_file="/var/lib/dhcp/dhcpd.leases"
cp $lease_file $lease_file.$(date "+%Y%m%d-%H%M%S")

if [ "$1" == 'MAC' ]
then
    MAC=$2
    awk -v MAC="$MAC" 'BEGIN{IN=0;ACCU=""} /^lease/{print ACCU;ACCU="";IN=1;do_print=1} /hardware ethernet/{if($3==MAC";"){do_print=0}} {ACCU=ACCU"\n"$0} /^}$/{if(do_print==1){print ACCU};IN=0;do_print=0;ACCU=""}' $lease_file > /tmp/$$
else
    HOST="\"$2\""
    awk -v HOST="$HOST" 'BEGIN{IN=0;ACCU=""} /^lease/{print ACCU;ACCU="";IN=1;do_print=1} /client-hostname/{if($2==HOST";"){do_print=0}} {ACCU=ACCU"\n"$0} /^}$/{if(do_print==1){print ACCU};IN=0;do_print=0;ACCU=""}' $lease_file > /tmp/$$
fi
sed '/^$/d' /tmp/$$ > $lease_file
systemctl restart isc-dhcp-server
