#!/bin/bash

SCHOOLS=$(/usr/bin/ls *.log | grep -v "getlogs.log" | sed 's/\.log$//')
for school in $SCHOOLS
do
    UPDATED=""
    FAILED=""
    file="$school.log"
    MACS=$(awk '/^Trying/{print $5}' $file | sed -e 's/(//' -e 's/)//')
    for mac in $MACS
    do
        name=$(grep "^Trying to boot .* ($mac)" $file | cut -d ' ' -f 4)
        host="$name-$mac"
        if [ $(grep "Begin host $name ($mac" -A 1  $file | grep "End host $name" -c) -eq 0 ]
        then
            UPDATED="$UPDATED $host"
        else
            FAILED="$FAILED $host"
        fi
    done
    nUpdated=$(echo $UPDATED | wc -w)
    nUpdatedTot=$(( $nUpdatedTot + $nUpdated))
    nFailed=$(echo $FAILED | wc -w)
    nFailedTot=$(( $nFailedTot + $nFailed))
    if [ $nFailed -gt 0 ]
    then
        SCHOOLS_FAILED="$SCHOOLS_FAILED $school"
    fi
    echo "===================== $school ============================"
    echo "Resultats pour l'école '$school'"
    echo -e "\tsur un total de $(( $nUpdated + $nFailed )) postes"
    echo -e "\t$nUpdated postes mis à jour ($UPDATED)"
    echo -e "\t$nFailed postes non contactés ($FAILED)"
    echo "========================================================="
done
nSchools=$(echo $SCHOOLS | wc -w)
nFailedSchools=$(echo $SCHOOLS_FAILED | wc -w)
echo "===================== Total ============================"
echo "Resultats globaux"
echo -e "\tsur un total de $(( $nUpdatedTot + $nFailedTot )) postes dans $nSchools écoles"
echo -e "\t$nUpdatedTot postes mis à jour"
echo -e "\t$nFailedTot postes non contactés dans $nFailedSchools écoles ($SCHOOLS_FAILED)"
echo "========================================================="
