#!/bin/bash

# Copyright (C) 2018  Tetras Libre <Contact@Tetras-Libre.fr>
# Author: Beniamine, David <David.Beniamine@Tetras-Libre.fr>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cd /opt
branch=eole-amon-ecole-2.8

if [ "$(dpkg -l | grep git)" ]
then
    apt-eole install \
        git \
        printer-driver-splix \
        hplip \
        wakeonlan
fi
if [ ! -e "eole-wol" ]
then
    git clone -b $branch https://gitecoles.grenoble.fr/grenoble/eole-wol
    cd eole-wol
else
    cd eole-wol
    git stash
    git fetch
    git switch $branch
    git pull origin $branch
fi

DIR=$PWD

cp -v $DIR/*/service/*.service /etc/systemd/system/

dpkg -i cups/deb/*.deb
apt-get -f install

# Adding services
systemctl daemon-reload
for service in wakeonlan registry
do
    systemctl restart $service
    systemctl status $service
    systemctl enable $service
done

# Add registry clean to cronab

line="0 1 1 * * $DIR/registry/scripts/clean.sh > /dev/null 2>&1"
(crontab -l | grep -v "registry"; echo "${line}") | crontab -

# Copy ssh key to ftp
while [ ! -e "/root/.ssh/id_rsa.pub" ]
do
    sleep 10
done

FTPPATH=/home/p/postinstall/perso
cp ~/.ssh/id_rsa.pub $FTPPATH/id_rsa.pub
