#!/bin/bash

# Copyright (C) 2018  Tetras Libre <Contact@Tetras-Libre.fr>
# Author: Beniamine, David <David.Beniamine@Tetras-Libre.fr>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cd /var/www
branch=eole-amon-ecole-2.8

if [ "$(dpkg -l | grep git)" ]
then
    apt-eole install \
        git \
        xrdp
fi
if [ ! -e "eole-wol" ]
then
    git clone -b $branch https://gitecoles.grenoble.fr/grenoble/eole-wol
else
    cd eole-wol
    git stash
    git fetch
    git switch $branch
    git pull origin $branch
    cd -
fi

chown -R www-data:www-data eole-wol/wol/www

mkdir -p /etc/xrdp
cp /var/www/eole-wol/wol/xrdp.ini /etc/xrdp
cp /var/www/eole-wol/wol/service/xrdp.service /etc/systemd/system/multi-user.target.wants/
systemctl daemon-reload
systemctl restart xrdp

# Reactivate ipv6
rm /etc/sysctl.d/50_disabled_ipv6.conf
sysctl -w net.ipv6.conf.all.disable_ipv6=0
